diff -r 1b0b563a81e6 mcabber/mcabber/commands.c
--- a/mcabber/mcabber/commands.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/commands.c	Wed May 15 12:48:30 2013 +0300
@@ -800,484 +1507,661 @@
   }
 }
 
-//  roster_updown(updown, nitems)
-// updown: -1=up, +1=down
-inline static void roster_updown(int updown, char *nitems)
+static gchar *do_roster (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  scmd_roster_bottom, scmd_roster_top, scmd_roster_up, scmd_roster_down,
+  scmd_roster_group_prev, scmd_roster_group_next,
+  scmd_roster_alternate,
+  scmd_roster_unread_first, scmd_roster_unread_next,
+  scmd_roster_search,
+  scmd_roster_display,
+  scmd_roster_hide_offline, scmd_roster_show_offline, scmd_roster_toggle_offline,
+  scmd_roster_item_lock, scmd_roster_item_unlock, scmd_roster_item_toggle_lock,
+  scmd_roster_note, scmd_roster_notes,
+  scmd_roster_resource_lock, scmd_roster_resource_unlock,
+  scmd_roster_hide, scmd_roster_show, scmd_roster_toggle,
+} scmd_roster_t;
+
+typedef enum {
+  pos_roster_scmd         = 0,
+  pos_roster_up_n         = 1,
+  pos_roster_down_n       = 1,
+  pos_roster_search_name  = 1,
+  pos_roster_display_mask = 1,
+  pos_roster_itemlock_jid = 1,
+  pos_roster_note_jid     = 1,
+  pos_roster_note_rst     = 2,
+  pos_roster_note_text    = 3,
+  pos_roster_reslock_jid  = 1,
+} pos_roster_t;
+
+#define SCMD_ROSTER(NAME, ARGS...) \
+    { #NAME, cmd_default, NULL, NULL, NULL, ARGS, NULL, (gpointer)scmd_roster_##NAME }
+static cmdopts_t def_roster = {
+  "roster",
+  cmd_default,
+  NULL,
+  do_roster,
+  NULL,
+  (cmdarg_t[2]){{"subcommand", pos_roster_scmd, cmdarg_subcmd | cmdarg_chreq, NULL, NULL},{NULL}},
+  (cmdopts_t[25]){
+    SCMD_ROSTER(bottom, NULL),
+    SCMD_ROSTER(top,    NULL),
+    SCMD_ROSTER(up,   (cmdarg_t[2]){{"n", pos_roster_up_n, cmdarg_chreq, "1", &cmdarg_type_uint, (gpointer)0},{NULL}}),
+    SCMD_ROSTER(down, (cmdarg_t[2]){{"n", pos_roster_down_n, cmdarg_chreq, "1", &cmdarg_type_uint (gpointer)0},{NULL}}),
+    SCMD_ROSTER(group_prev, NULL),
+    SCMD_ROSTER(group_next, NULL),
+    SCMD_ROSTER(alternate, NULL),
+    SCMD_ROSTER(unread_first, NULL),
+    SCMD_ROSTER(unread_next,  NULL),
+    SCMD_ROSTER(search, (cmdarg_t[2]){{"name", pos_roster_search_name, cmdarg_eol|cmdarg_required, NULL, &cmdarg_type_nonspace},{NULL}}),
+    SCMD_ROSTER(display, (cmdarg_t[2]){{"statusmask", pos_roster_display_mask, cmdarg_check, NULL, &cmdarg_type_charset, (gpointer)"ofdna_?"},{NULL}}),
+    SCMD_ROSTER(hide_offline,   NULL),
+    SCMD_ROSTER(show_offline,   NULL),
+    SCMD_ROSTER(toggle_offline, NULL),
+    SCMD_ROSTER(item_lock,        (cmdarg_t[2]){{"jid", pos_roster_itemlock_jid, cmdarg_chreq, ".", &cmdarg_type_buddy, (gpointer)cmdarg_roster_entity},{NULL}}),
+    SCMD_ROSTER(item_unlock,      (cmdarg_t[2]){{"jid", pos_roster_itemlock_jid, cmdarg_chreq, ".", &cmdarg_type_buddy, (gpointer)cmdarg_roster_entity},{NULL}}),
+    SCMD_ROSTER(item_toggle_lock, (cmdarg_t[2]){{"jid", pos_roster_itemlock_jid, cmdarg_chreq, ".", &cmdarg_type_buddy, (gpointer)cmdarg_roster_entity},{NULL}}),
+    { "note", cmd_default, NULL, NULL,
+      (cmdopt_t[3]){
+        {'r', "reset", {"reset", pos_roster_note_rst, cmdarg_switch, NULL, NULL, NULL}},
+        {'j', "jid",   {"jid",   pos_roster_note_jid, cmdarg_chreq, ".", &cmdarg_type_buddy, (gpointer)cmdarg_roster_entity}},
+        {0}
+      },
+      (cmdarg_t[2]){
+        {"text", pos_roster_note_text, cmdarg_eol, NULL, &cmdarg_type_nonspace},
+        {NULL}
+      },
+      NULL, (gpointer)scmd_roster_note
+    },
+    SCMD_ROSTER(notes, NULL),
+    SCMD_ROSTER(resource_lock,   (cmdarg_t[2]){{"resource|fjid", pos_roster_reslock_jid, cmdarg_chreq, NULL, &cmdarg_type_buddy, (gpointer)cmdarg_roster_buddy},{NULL}}),
+    SCMD_ROSTER(resource_unlock, (cmdarg_t[2]){{"jid", pos_roster_reslock_jid, cmdarg_chreq, ".", &cmdarg_type_buddy, (gpointer)cmdarg_roster_buddy},{NULL}}),
+    SCMD_ROSTER(hide,   NULL),
+    SCMD_ROSTER(show,   NULL),
+    SCMD_ROSTER(toggle, NULL),
+    {NULL}
+  },
+};
+
+static gchar *do_roster (const cmdopts_t *options, cmdarg_value_t *values)
 {
-  int nbitems;
-
-  if (!nitems || !*nitems)
-    nbitems = 1;
-  else
-    nbitems = strtol(nitems, NULL, 10);
-
-  if (nbitems > 0)
-    scr_roster_up_down(updown, nbitems);
-}
-
-/* Commands callback functions */
-/* All these do_*() functions will be called with a "arg" parameter */
-/* (with arg not null)                                              */
-
-static void do_roster(char *arg)
-{
-  char **paramlst;
-  char *subcmd;
-
-  paramlst = split_arg(arg, 2, 1); // subcmd, arg
-  subcmd = *paramlst;
-  arg = *(paramlst+1);
-
-  if (!subcmd || !*subcmd) {
-    scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-    free_arg_lst(paramlst);
-    return;
-  }
-
-  if (!strcasecmp(subcmd, "top")) {
+  scmd_roster_t subcmd = (scmd_roster_t) (values[pos_roster_scmd].value.cmd -> userdata);
+
+  if (subcmd == scmd_roster_bottom) {
+    scr_roster_bottom();
+    update_roster = TRUE;
+  } else if (subcmd == scmd_roster_top) {
     scr_roster_top();
     update_roster = TRUE;
-  } else if (!strcasecmp(subcmd, "bottom")) {
-    scr_roster_bottom();
+  } else if (subcmd == scmd_roster_up) {
+    scr_roster_up_down(-1, values[pos_roster_up_n].value.uint);
+  } else if (subcmd == scmd_roster_down) {
+    scr_roster_up_down(1, values[pos_roster_down_n].value.uint);
+  } else if (subcmd == scmd_roster_group_prev) {
+    scr_roster_prev_group();
+  } else if (subcmd == scmd_roster_group_next) {
+    scr_roster_next_group();
+  } else if (subcmd == scmd_roster_alternate) {
+    scr_roster_jump_alternate();
+  } else if (subcmd == scmd_roster_unread_first) {
+    scr_roster_unread_message(0);
+  } else if (subcmd == scmd_roster_unread_next) {
+    scr_roster_unread_message(1);
+  } else if (subcmd == scmd_roster_search) {
+    scr_roster_search(values[pos_roster_search_name].value.arg);
     update_roster = TRUE;
-  } else if (!strcasecmp(subcmd, "hide")) {
-    scr_roster_visibility(0);
-  } else if (!strcasecmp(subcmd, "show")) {
-    scr_roster_visibility(1);
-  } else if (!strcasecmp(subcmd, "toggle")) {
-    scr_roster_visibility(-1);
-  } else if (!strcasecmp(subcmd, "hide_offline")) {
+  } else if (subcmd == scmd_roster_display) {
+    scr_roster_display(values[pos_roster_display_mask].value.arg);
+  } else if (subcmd == scmd_roster_hide_offline) {
     buddylist_set_hide_offline_buddies(TRUE);
-    if (current_buddy)
+    if (current_buddy) // XXX
       buddylist_build();
     update_roster = TRUE;
-  } else if (!strcasecmp(subcmd, "show_offline")) {
+  } else if (subcmd == scmd_roster_show_offline) {
     buddylist_set_hide_offline_buddies(FALSE);
     buddylist_build();
     update_roster = TRUE;
-  } else if (!strcasecmp(subcmd, "toggle_offline")) {
+  } else if (subcmd == scmd_roster_toggle_offline) {
     buddylist_set_hide_offline_buddies(-1);
     buddylist_build();
     update_roster = TRUE;
-  } else if (!strcasecmp(subcmd, "display")) {
-    scr_roster_display(arg);
-  } else if (!strcasecmp(subcmd, "item_lock")) {
-    roster_buddylock(arg, 1);
-  } else if (!strcasecmp(subcmd, "item_unlock")) {
-    roster_buddylock(arg, 0);
-  } else if (!strcasecmp(subcmd, "item_toggle_lock")) {
-    roster_buddylock(arg, -1);
-  } else if (!strcasecmp(subcmd, "unread_first")) {
-    scr_roster_unread_message(0);
-  } else if (!strcasecmp(subcmd, "unread_next")) {
-    scr_roster_unread_message(1);
-  } else if (!strcasecmp(subcmd, "alternate")) {
-    scr_roster_jump_alternate();
-  } else if (!strncasecmp(subcmd, "search", 6)) {
-    strip_arg_special_chars(arg);
-    if (!arg || !*arg) {
-      scr_LogPrint(LPRINT_NORMAL, "What name or JID are you looking for?");
-      free_arg_lst(paramlst);
-      return;
-    }
-    scr_roster_search(arg);
-    update_roster = TRUE;
-  } else if (!strcasecmp(subcmd, "up")) {
-    roster_updown(-1, arg);
-  } else if (!strcasecmp(subcmd, "down")) {
-    roster_updown(1, arg);
-  } else if (!strcasecmp(subcmd, "group_prev")) {
-    scr_roster_prev_group();
-  } else if (!strcasecmp(subcmd, "group_next")) {
-    scr_roster_next_group();
-  } else if (!strcasecmp(subcmd, "note")) {
-    roster_note(arg);
-  } else if (!strcasecmp(subcmd, "resource_lock")) {
-    roster_resourcelock(arg, TRUE);
-  } else if (!strcasecmp(subcmd, "resource_unlock")) {
-    roster_resourcelock(arg, FALSE);
-  } else
-    scr_LogPrint(LPRINT_NORMAL, "Unrecognized parameter!");
-  free_arg_lst(paramlst);
+  } else if (subcmd == scmd_roster_item_lock) {
+    roster_buddylock(values[pos_roster_itemlock_jid].value.rjid.bud, 1);
+  } else if (subcmd == scmd_roster_item_unlock) {
+    roster_buddylock(values[pos_roster_itemlock_jid].value.rjid.bud, 0);
+  } else if (subcmd == scmd_roster_item_toggle_lock) {
+    roster_buddylock(values[pos_roster_itemlock_jid].value.rjid.bud, -1);
+  } else if (subcmd == scmd_roster_note) {
+    roster_note(values[pos_roster_note_jid].value.rjid.bud,
+                values[pos_roster_note_rst].value.swc,
+                values[pos_roster_note_text].value.arg);
+  } else if (subcmd == scmd_roster_notes) {
+    display_all_annotations();
+  } else if (subcmd == scmd_roster_resource_lock) {
+    buddy_setactiveresource(values[pos_roster_reslock_jid].value.rjid.bud,
+                            values[pos_roster_reslock_jid].value.rjid.resource);
+    scr_update_chat_status(TRUE);
+  } else if (subcmd == scmd_roster_resource_unlock) {
+    buddy_setactiveresource(values[pos_roster_reslock_jid].value.rjid.bud, NULL);
+    scr_update_chat_status(TRUE);
+  } else if (subcmd == scmd_roster_hide) {
+    scr_roster_visibility(0);
+  } else if (subcmd == scmd_roster_show) {
+    scr_roster_visibility(1);
+  } else { // scmd_roster_toggle
+    scr_roster_visibility(-1);
+  }
+
+  return NULL;
 }
 
-void do_color(char *arg)
+//
+//  /color
+//
+
+// custom argument types
+
+// statusmask + "clear"
+// Needs status char set in chkdata.
+static gchar *cmdarg_check_color_statusmask (cmdarg_value_t *arg)
 {
-  char **paramlst;
-  char *subcmd;
-
-  paramlst = split_arg(arg, 2, 1); // subcmd, arg
-  subcmd = *paramlst;
-  arg = *(paramlst+1);
-
-  if (!subcmd || !*subcmd) {
-    scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-    free_arg_lst(paramlst);
-    return;
-  }
-
-  if (!strcasecmp(subcmd, "roster")) {
-    char *status, *wildcard, *color;
-    char **arglist = split_arg(arg, 3, 0);
-
-    status = *arglist;
-    wildcard = to_utf8(arglist[1]);
-    color = arglist[2];
-
-    if (status && !strcmp(status, "clear")) { // Not a color command, clear all
+  if (!g_strcmp0 (arg -> value.arg, "clear"))
+    return NULL;
+  else
+    return cmdarg_check_charset (arg);
+}
+
+static const cmdarg_type_t cmdarg_type_color_statusmask = {
+  cmdarg_check_color_statusmask,
+  NULL,
+  NULL,
+};
+
+// bjid + "*"
+static gchar *cmdarg_check_color_roomjid (cmdarg_value_t *arg)
+{
+  if (!g_strcmp0 (arg -> value.arg, "*"))
+    return NULL;
+  else
+    return cmdarg_check_bjid (arg);
+}
+
+static const cmdarg_type_t cmdarg_type_color_roomjid = {
+  cmdarg_check_color_roomjid,
+  NULL,
+  NULL,
+};
+
+// TODO: completion, that says, which roster jids do match
+static const cmdarg_type_t cmdarg_type_bjidmask = {
+  cmdarg_check_nonspace,
+  NULL,
+  NULL,
+};
+
+// TODO: completion, based on current room nicks
+static const cmdarg_type_t cmdarg_type_nick = {
+  cmdarg_check_nonspace,
+  NULL,
+  NULL,
+};
+
+// command
+
+static gchar *do_color (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  scmd_color_roster,
+  scmd_color_mucnick,
+  scmd_color_muc,
+} scmd_color_t;
+
+typedef enum {
+  pos_color_scmd          = 0,
+  pos_color_roster_status = 1,
+  pos_color_roster_jid    = 2,
+  pos_color_roster_color  = 3,
+  pos_color_muc_room      = 1,
+  pos_color_muc_mode      = 2,
+  pos_color_nick_nick     = 1,
+  pos_color_nick_color    = 2,
+} pos_color_t;
+
+static const string2enum_t s2e_color_muc[] = {
+  { "on",     MC_ALL    },
+  { "off",    MC_OFF    },
+  { "preset", MC_PRESET },
+  { "-",      MC_REMOVE },
+  { NULL,     0         },
+};
+
+static cmdopts_t def_color = {
+  "color",
+  cmd_safe,
+  NULL,
+  do_color,
+  NULL,
+  (cmdarg_t[2]){{ "subcommand", pos_color_scmd, cmdarg_subcmd | cmdarg_chreq, NULL, NULL },{NULL}},
+  (cmdopts_t[4]){
+    {"roster", cmd_default, NULL, NULL, NULL, (cmdarg_t[4]){
+        { "statusmask|clear", pos_color_roster_status, cmdarg_chreq, NULL, &cmdarg_type_color_statusmask, (gpointer)"ofdna_?" },
+        { "jidmask",          pos_color_roster_jid,    cmdarg_check, NULL, &cmdarg_type_bjidmask },
+        { "color|-",          pos_color_roster_color,  cmdarg_check, NULL, &cmdarg_type_color },
+        {NULL}
+      }, NULL, (gpointer)scmd_color_roster},
+    {"muc", cmd_default, NULL, NULL, NULL, (cmdarg_t[3]){
+        { "roomjid",         pos_color_muc_room, cmdarg_chreq, NULL, &cmdarg_type_color_roomjid, (gpointer)cmdarg_roster_room },
+        { "on|off|preset|-", pos_color_muc_mode, cmdarg_chreq, "on", &cmdarg_type_string2enum, (gpointer)s2e_color_muc },
+        {NULL}
+      }, NULL, (gpointer)scmd_color_muc},
+    {"mucnick", cmd_default, NULL, NULL, NULL, (cmdarg_t[3]){
+        { "nick",    pos_color_nick_nick,  cmdarg_chreq, NULL, &cmdarg_type_nick },
+        { "color|-", pos_color_nick_color, cmdarg_chreq, NULL, &cmdarg_type_color },
+        {NULL}
+      }, NULL, (gpointer)scmd_color_mucnick},
+    {NULL}
+  },
+};
+
+static gchar *do_color (const cmdopts_t *options, cmdarg_value_t *values)
+{
+  scmd_color_t subcmd = (scmd_color_t) (values[pos_color_scmd].value.cmd -> userdata);
+
+  if (subcmd == scmd_color_roster) {
+    const gchar *status   = values[pos_color_roster_status].value.arg;
+    const gchar *wildcard = values[pos_color_roster_jid].value.arg;
+    const gchar *color    = values[pos_color_roster_color].value.arg;
+    if (!strcmp(status, "clear")) { // Not a color command, clear all
       scr_roster_clear_color();
       update_roster = TRUE;
     } else {
-      if (!status || !*status || !wildcard || !*wildcard || !color || !*color) {
-        scr_LogPrint(LPRINT_NORMAL, "Missing argument");
+      if ((!wildcard) || (!color)) {
+        // freaking "clear" :(
+        return g_strdup ("Missing argument.");
       } else {
         update_roster = scr_roster_color(status, wildcard, color) ||
                         update_roster;
       }
     }
-    free_arg_lst(arglist);
-    g_free(wildcard);
-  } else if (!strcasecmp(subcmd, "muc")) {
-    char **arglist = split_arg(arg, 2, 0);
-    char *free_muc = to_utf8(*arglist);
-    const char *muc = free_muc, *mode = arglist[1];
-    if (!muc || !*muc)
-      scr_LogPrint(LPRINT_NORMAL, "What MUC?");
-    else {
-      if (!strcmp(muc, "."))
-        if (!(muc = CURRENT_JID))
-          scr_LogPrint(LPRINT_NORMAL, "No JID selected");
-      if (muc) {
-        if (check_jid_syntax(muc) && strcmp(muc, "*"))
-          scr_LogPrint(LPRINT_NORMAL, "Not a JID");
-        else {
-          if (!mode || !*mode || !strcasecmp(mode, "on"))
-            scr_muc_color(muc, MC_ALL);
-          else if (!strcasecmp(mode, "preset"))
-            scr_muc_color(muc, MC_PRESET);
-          else if (!strcasecmp(mode, "off"))
-            scr_muc_color(muc, MC_OFF);
-          else if (!strcmp(mode, "-"))
-            scr_muc_color(muc, MC_REMOVE);
-          else
-            scr_LogPrint(LPRINT_NORMAL, "Unknown coloring mode");
-        }
-      }
-    }
-    free_arg_lst(arglist);
-    g_free(free_muc);
-  } else if (!strcasecmp(subcmd, "mucnick")) {
-    char **arglist = split_arg(arg, 2, 0);
-    const char *nick = *arglist, *color = arglist[1];
-    if (!nick || !*nick || !color || !*color)
-      scr_LogPrint(LPRINT_NORMAL, "Missing argument");
-    else
-      scr_muc_nick_color(nick, color);
-    free_arg_lst(arglist);
-  } else
-    scr_LogPrint(LPRINT_NORMAL, "Unrecognized parameter!");
-  free_arg_lst(paramlst);
+  } else if (subcmd == scmd_color_muc) {
+    scr_muc_color ( values[pos_color_muc_room].value.arg,
+                    values[pos_color_muc_mode].value.uint );
+  } else { // scmd_color_mucnick
+    scr_muc_nick_color( values[pos_color_nick_nick].value.arg,
+                        values[pos_color_nick_color].value.arg );
+  }
+
+  return NULL;
 }
 
-//  cmd_setstatus(recipient, arg)
-// Set your Jabber status.
-// - if recipient is not NULL, the status is sent to this contact only
-// - arg must be "status message" (message is optional)
-void cmd_setstatus(const char *recipient, const char *arg)
+//
+//  /status
+//
+
+// custom type
+
+// needs corresponding s2e in chkdata
+static gchar *cmdarg_check_status_status (cmdarg_value_t *arg)
 {
-  char **paramlst;
-  char *status;
-  char *msg;
-  enum imstatus st;
-
-  if (!xmpp_is_online())
-    scr_LogPrint(LPRINT_NORMAL, "You are currently not connected...");
-  // We do not return now, so that the status is memorized and used later...
-
-  // It makes sense to reset autoaway before changing the status
-  // (esp. for FIFO or remote commands) or the behaviour could be
-  // unexpected...
-  if (!recipient)
-    scr_check_auto_away(TRUE);
-
-  paramlst = split_arg(arg, 2, 1); // status, message
-  status = *paramlst;
-  msg = *(paramlst+1);
-
-  if (!status) {
-    free_arg_lst(paramlst);
-    return;
+  if (!g_strcmp0(arg -> value.arg, "message")) {
+    arg -> value.uint = xmpp_getstatus(); // Preserve current status
+    return NULL;
   }
 
-  if      (!strcasecmp(status, IMSTATUS_OFFLINE))       st = offline;
-  else if (!strcasecmp(status, IMSTATUS_ONLINE))        st = available;
-  else if (!strcasecmp(status, IMSTATUS_AVAILABLE))     st = available;
-  else if (!strcasecmp(status, IMSTATUS_AWAY))          st = away;
+  return cmdarg_check_string2enum (arg);
+}
+
+static const cmdarg_type_t cmdarg_type_status_status = {
+  cmdarg_check_status_status,
+  NULL,
+  NULL,
+};
+
+// command
+
+static gchar *do_status (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_status_status  = 0,
+  pos_status_jid     = 1,
+  pos_status_message = 2,
+} pos_status_t;
+
+static const string2enum_t s2e_status2[] = {
+  { "away",      away        },
+  { "offline",   offline     },
+  { "online",    available   },
+  { "avail",     available   },
+  { "notavail",  notavail    },
+  { "dnd",       dontdisturb },
+  { "free",      freeforchat },
 #ifdef WITH_DEPRECATED_STATUS_INVISIBLE
-  else if (!strcasecmp(status, IMSTATUS_INVISIBLE))     st = invisible;
+  { "invisible", invisible   },
 #endif
-  else if (!strcasecmp(status, IMSTATUS_DONOTDISTURB))  st = dontdisturb;
-  else if (!strcasecmp(status, IMSTATUS_NOTAVAILABLE))  st = notavail;
-  else if (!strcasecmp(status, IMSTATUS_FREE4CHAT))     st = freeforchat;
-  else if (!strcasecmp(status, "message")) {
-    if (!msg || !*msg) {
-      // We want a message.  If there's none, we give up.
-      scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-      free_arg_lst(paramlst);
-      return;
-    }
-    st = xmpp_getstatus();  // Preserve current status
-  } else {
-    scr_LogPrint(LPRINT_NORMAL, "Unrecognized status!");
-    free_arg_lst(paramlst);
-    return;
-  }
-
-  // Use provided message
-  if (msg && !*msg) {
-    msg = NULL;
-  }
-
-  // If a recipient is specified, let's don't use default status messages
-  if (recipient && !msg)
-    msg = "";
-
-  xmpp_setstatus(st, recipient, msg, FALSE);
-
-  free_arg_lst(paramlst);
-}
-
-static void do_status(char *arg)
+  // XXX ugly
+  { "show",      imstatus_size},
+  { NULL,        0           },
+};
+
+static cmdopts_t def_status = {
+  "status",
+  cmd_safe,
+  NULL,
+  do_status,
+  (cmdopt_t[2]){
+    { 't', "to",
+           { "jid", pos_status_jid, cmdarg_default, NULL, &cmdarg_type_fjid }, (gpointer)cmdarg_roster_entity },
+    {0}
+  },
+  (cmdarg_t[3]){
+    { "status",  pos_status_status,  cmdarg_chreq, "show",
+                 &cmdarg_type_status_status, (gpointer)s2e_status2 },
+    { "message", pos_status_message, cmdarg_eol,   NULL,
+                 &cmdarg_type_nonspace },
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_status (const cmdopts_t *options, cmdarg_value_t *values)
 {
-  if (!*arg) {
+  if (values[pos_status_status].value.uint == imstatus_size) {
     const char *sm = xmpp_getstatusmsg();
     scr_LogPrint(LPRINT_NORMAL, "Your status is: [%c] %s",
                  imstatus2char[xmpp_getstatus()],
                  (sm ? sm : ""));
-    return;
+  } else {
+    if (!xmpp_is_online())
+      scr_LogPrint(LPRINT_NORMAL, "You are currently not connected...");
+    scr_check_auto_away(TRUE);
+    xmpp_setstatus(values[pos_status_status].value.uint,
+                   values[pos_status_jid].value.arg,
+                   values[pos_status_message].value.arg, FALSE);
   }
-  arg = to_utf8(arg);
-  cmd_setstatus(NULL, arg);
-  g_free(arg);
+  return NULL;
 }
 
-static void do_status_to(char *arg)
+//
+//  /status_to
+//
+
+static gchar *do_status_to (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_statusto_jid     = 0,
+  pos_statusto_status  = 1,
+  pos_statusto_message = 2,
+} pos_statusto_t;
+
+// no "show" here
+static const string2enum_t s2e_status[] = {
+  { "away",      away        },
+  { "offline",   offline     },
+  { "online",    available   },
+  { "avail",     available   },
+  { "notavail",  notavail    },
+  { "dnd",       dontdisturb },
+  { "free",      freeforchat },
+#ifdef WITH_DEPRECATED_STATUS_INVISIBLE
+  { "invisible", invisible   },
+#endif
+  { NULL,        0           },
+};
+
+static cmdopts_t def_status_to = {
+  "status_to",
+  cmd_default,
+  NULL,
+  do_status_to,
+  NULL,
+  (cmdarg_t[4]){
+    {"jid",     pos_statusto_jid,     cmdarg_chreq, NULL, &cmdarg_type_fjid, (gpointer)cmdarg_roster_entity},
+    {"status",  pos_statusto_status,  cmdarg_chreq, NULL, &cmdarg_type_status_status, (gpointer)s2e_status},
+    {"message", pos_statusto_message, cmdarg_eol,   NULL, &cmdarg_type_nonspace},
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_status_to (const cmdopts_t *options, cmdarg_value_t *values)
 {
-  char **paramlst;
-  char *fjid, *st, *msg;
-  char *jid_utf8 = NULL;
-
-  paramlst = split_arg(arg, 3, 1); // jid, status, [message]
-  fjid = *paramlst;
-  st = *(paramlst+1);
-  msg = *(paramlst+2);
-
-  if (!fjid || !st) {
-    scr_LogPrint(LPRINT_NORMAL,
-                 "Please specify both a Jabber ID and a status.");
-    free_arg_lst(paramlst);
-    return;
+  const char *fjid, *stname, *msg;
+  enum imstatus st;
+
+  fjid = values[pos_statusto_jid].value.arg;
+  st   = values[pos_statusto_status].value.uint;
+  msg  = values[pos_statusto_message].value.arg;
+
+  { // get status name
+    const string2enum_t *list;
+    for (list = s2e_status; list -> name != NULL; list ++)
+      if (list -> value == st) {
+        stname = list -> name;
+        break;
+      }
   }
-
-  // Allow things like /status_to "" away
-  if (!*fjid || !strcmp(fjid, "."))
-    fjid = NULL;
-
-  if (fjid) {
-    // The JID has been specified.  Quick check...
-    if (check_jid_syntax(fjid)) {
-      scr_LogPrint(LPRINT_NORMAL|LPRINT_NOTUTF8,
-                   "<%s> is not a valid Jabber ID.", fjid);
-      fjid = NULL;
-    } else {
-      // Convert jid to lowercase
-      char *p = fjid;
-      for ( ; *p && *p != JID_RESOURCE_SEPARATOR; p++)
-        *p = tolower(*p);
-      fjid = jid_utf8 = to_utf8(fjid);
-    }
+  // prevent default status message
+  msg = msg ? msg : "";
+
+  scr_log_print (LPRINT_LOGNORM, 
+                 "Sending to <%s> /status %s %s", fjid, stname, msg);
+  if (!xmpp_is_online())
+    scr_log_print (LPRINT_NORMAL, "You are currently not connected...");
+  xmpp_setstatus(st, fjid, msg, FALSE);
+
+  return NULL;
+}
+
+//
+//  /add
+//
+
+static gchar *do_add (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_add_jid  = 0,
+  pos_add_name = 1,
+} pos_add_t;
+
+static cmdopts_t def_add = {
+  "add",
+  cmd_default,
+  cmd_check_online,
+  do_add,
+  NULL,
+  (cmdarg_t[3]){
+    { "jid",  pos_add_jid,  cmdarg_chreq,   ".",  &cmdarg_type_bjid, (gpointer)cmdarg_roster_entity },
+    { "name", pos_add_name, cmdarg_default, NULL, &cmdarg_type_nonspace },
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_add (const cmdopts_t *options, cmdarg_value_t *values)
+{
+  gchar *jid = values[pos_add_jid].value.arg;
+
+  // XXX
+  //mc_strtolower(jid);
+
+  xmpp_addbuddy(jid, values[pos_add_name].value.arg, NULL);
+  scr_log_print (LPRINT_LOGNORM, "Sent presence notification request to <%s>.",
+                 jid);
+
+  return NULL;
+}
+
+//
+//  /del
+//
+
+static gchar *do_del (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_del_jid    = 0,
+  pos_del_dryrun = 1,
+} pos_del_t;
+
+static cmdopts_t def_del = {
+  "del",
+  cmd_default,
+  cmd_check_online,
+  do_del,
+  (cmdopt_t[2]){
+    { 'n', "dryrun",
+      { "dryrun", pos_del_dryrun, cmdarg_trigger, NULL, NULL } },
+    {0}
+  },
+  (cmdarg_t[2]){
+    { "jid", pos_del_jid, cmdarg_chreq, ".", &cmdarg_type_buddy, (gpointer)cmdarg_roster_entity },
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_del (const cmdopts_t *options, cmdarg_value_t *values)
+{
+  gpointer   buddy = values[pos_del_jid].value.rjid.bud;
+  const char *jid  = buddy_getjid (buddy);
+
+  if (buddy_gettype(buddy) & ROSTER_TYPE_ROOM)
+    // This is a chatroom
+    if (buddy_getinsideroom(buddy))
+      return g_strdup_printf ("You have to leave room <%s> before deleting it!",
+                              jid);
+
+  scr_log_print (LPRINT_LOGNORM, "Removing <%s>...", jid);
+
+  if (values[pos_del_dryrun].value.swc) {
+    scr_log_print (LPRINT_LOGNORM, "... not really.");
   } else {
-    // Add the current buddy
-    if (current_buddy)
-      fjid = (char*)buddy_getjid(BUDDATA(current_buddy));
-    if (!fjid)
-      scr_LogPrint(LPRINT_NORMAL, "Please specify a Jabber ID.");
+    // Close the buffer
+    scr_buffer_purge(1, jid);
+
+    xmpp_delbuddy(jid);
+    scr_update_buddy_window();
   }
 
-  if (fjid) {
-    char *cmdline;
-    if (!msg)
-      msg = "";
-    msg = to_utf8(msg);
-    cmdline = g_strdup_printf("%s %s", st, msg);
-    scr_LogPrint(LPRINT_LOGNORM, "Sending to <%s> /status %s", fjid, cmdline);
-    cmd_setstatus(fjid, cmdline);
-    g_free(msg);
-    g_free(cmdline);
-    g_free(jid_utf8);
-  }
-  free_arg_lst(paramlst);
+  return NULL;
 }
 
-static void do_add(char *arg)
+//
+//  /group
+//
+
+static void group_cmd (gpointer group, scmd_group_t action) 
 {
-  char **paramlst;
-  char *id, *nick;
-  char *jid_utf8 = NULL;
-
-  if (!xmpp_is_online()) {
-    scr_LogPrint(LPRINT_NORMAL, "You are not connected.");
-    return;
-  }
-
-  paramlst = split_arg(arg, 2, 0); // jid, [nickname]
-  id = *paramlst;
-  nick = *(paramlst+1);
-
-  if (!id)
-    nick = NULL; // Allow things like: /add "" nick
-  else if (!*id || !strcmp(id, "."))
-    id = NULL;
-
-  if (id) {
-    // The JID has been specified.  Quick check...
-    if (check_jid_syntax(id)) {
-      scr_LogPrint(LPRINT_NORMAL|LPRINT_NOTUTF8,
-                   "<%s> is not a valid Jabber ID.", id);
-      id = NULL;
-    } else {
-      mc_strtolower(id);
-      id = jid_utf8 = to_utf8(id);
-    }
-  } else {
-    // Add the current buddy
-    if (current_buddy)
-      id = (char*)buddy_getjid(BUDDATA(current_buddy));
-    if (!id)
-      scr_LogPrint(LPRINT_NORMAL, "Please specify a Jabber ID.");
-  }
-
-  if (nick)
-    nick = to_utf8(nick);
-
-  if (id) {
-    // 2nd parameter = optional nickname
-    xmpp_addbuddy(id, nick, NULL);
-    scr_LogPrint(LPRINT_LOGNORM, "Sent presence notification request to <%s>.",
-                 id);
-  }
-
-  g_free(jid_utf8);
-  g_free(nick);
-  free_arg_lst(paramlst);
-}
-
-static void do_del(char *arg)
-{
-  const char *bjid;
-
-  if (*arg) {
-    scr_LogPrint(LPRINT_NORMAL, "This action does not require a parameter; "
-                 "the currently-selected buddy will be deleted.");
-    return;
-  }
-
-  if (!current_buddy)
-    return;
-  bjid = buddy_getjid(BUDDATA(current_buddy));
-  if (!bjid)
-    return;
-
-  if (buddy_gettype(BUDDATA(current_buddy)) & ROSTER_TYPE_ROOM) {
-    // This is a chatroom
-    if (buddy_getinsideroom(BUDDATA(current_buddy))) {
-      scr_LogPrint(LPRINT_NORMAL, "You haven't left this room!");
-      return;
-    }
-  }
-
-  // Close the buffer
-  scr_buffer_purge(1, NULL);
-
-  scr_LogPrint(LPRINT_LOGNORM, "Removing <%s>...", bjid);
-  xmpp_delbuddy(bjid);
-  scr_update_buddy_window();
-}
-
-static void do_group(char *arg)
-{
-  gpointer group = NULL;
-  guint leave_buddywindow;
-  char **paramlst;
-  char *subcmd;
-  enum { group_toggle = -1, group_unfold = 0, group_fold = 1 } group_state = 0;
-
-  if (!*arg) {
-    scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-    return;
-  }
-
-  if (!current_buddy)
-    return;
-
-  paramlst = split_arg(arg, 2, 0); // subcmd, [arg]
-  subcmd = *paramlst;
-  arg = *(paramlst+1);
-
-  if (!subcmd || !*subcmd)
-    goto do_group_return;   // Should not happen
-
-  if (!strcasecmp(subcmd, "expand") || !strcasecmp(subcmd, "unfold"))
-    group_state = group_unfold;
-  else if (!strcasecmp(subcmd, "shrink") || !strcasecmp(subcmd, "fold"))
-    group_state = group_fold;
-  else if (!strcasecmp(subcmd, "toggle"))
-    group_state = group_toggle;
-  else {
-    scr_LogPrint(LPRINT_NORMAL, "Unrecognized parameter!");
-    goto do_group_return;
-  }
-
-  if (arg && *arg) {
-    GSList *roster_elt;
-    char *group_utf8 = to_utf8(arg);
-    roster_elt = roster_find(group_utf8, namesearch, ROSTER_TYPE_GROUP);
-    g_free(group_utf8);
-    if (roster_elt)
-      group = buddy_getgroup(roster_elt->data);
-  } else {
-    group = buddy_getgroup(BUDDATA(current_buddy));
-  }
-  if (!group) {
-    scr_LogPrint(LPRINT_NORMAL, "Group not found.");
-    goto do_group_return;
-  }
-
   // We'll have to redraw the chat window if we're not currently on the group
   // entry itself, because it means we'll have to leave the current buddy
   // chat window.
-  leave_buddywindow = (group != BUDDATA(current_buddy) &&
-                       group == buddy_getgroup(BUDDATA(current_buddy)));
-
-  if (!(buddy_gettype(group) & ROSTER_TYPE_GROUP)) {
-    scr_LogPrint(LPRINT_NORMAL, "You need to select a group.");
-    goto do_group_return;
-  }
-
-  if (group_state != group_unfold && leave_buddywindow)
+  if (action != scmd_group_unfold &&
+      ((!current_buddy) ||
+       (group != BUDDATA(current_buddy) &&
+        group == buddy_getgroup(BUDDATA(current_buddy)))))
     scr_roster_prev_group();
 
-  buddy_hide_group(group, group_state);
+  buddy_hide_group(group, action);
 
   buddylist_build();
   update_roster = TRUE;
-
-do_group_return:
-  free_arg_lst(paramlst);
 }
 
+static gchar *do_group (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_group_group  = 0,
+  pos_group_action = 1,
+} pos_group_t;
+
+static const string2enum_t s2e_group_scmd[] = {
+  { "expand", scmd_group_unfold },
+  { "unfold", scmd_group_unfold },
+  { "shrink", scmd_group_fold   },
+  { "fold",   scmd_group_fold   },
+  { "toggle", scmd_group_toggle },
+  { NULL,     0                 },
+};
+
+#define SCMD_GROUP(NAME, REALNAME) \
+    { #NAME, cmd_default, NULL, NULL, NULL, NULL, NULL, \
+             (gpointer)scmd_group_##REALNAME }
+static cmdopts_t def_group = {
+  "group",
+  cmd_default,
+  NULL,
+  do_group,
+  NULL,
+  (cmdarg_t[3]){
+    { "subcommand", pos_group_action, cmdarg_chreq,              NULL,
+                    &cmdarg_type_string2enum, (gpointer)s2e_group_scmd },
+    { "group",      pos_group_group,  cmdarg_chreq | cmdarg_eol, ".",
+                    &cmdarg_type_buddy, (gpointer)cmdarg_roster_grouponly },
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_group(const cmdopts_t *options, cmdarg_value_t *values)
+{
+  //if (!current_buddy) // XXX do we need this still?
+  //  return g_strdup("Command needs selected buddy.");
+
+  group_cmd (values[pos_group_group].value.rjid.bud,
+             values[pos_group_action].value.uint);
+
+  return NULL;
+}
+
+//
+//  /say
+//
+
+// FIXME: remove excessive checks, simplify this all. Uses:
+// send_message_to():
+// - send_message()
+// - /msay send_to
+// - /say_to
+// - /room privmsg
+// send_message():
+// - say_cmd()
+// - /msay send
+// say_cmd():
+// - process_line()
+// - /say
+// Probably at least send_message can be removed, and /msay send can use
+// say_cmd().
+// 
+// say_cmd() does:
+// - scr_set_chatmode(TRUE);
+// - scr_show_buddy_window();
+// - check current buddy presence and type
+// - buddy_setflags(bud, ROSTER_FLAG_LOCK, TRUE);
+// send_message() does:
+// - check current buddy presence and jid availability (type check should ensure that, I think)
+// - determines active resource of current buddy
+// send_message_to() does:
+// - checks online
+// - checks jid presence
+// - checks message presence
+// - checks syntax of jid
+// - converts message type
+// - extracts bare jid (for hook)
+// - jumps to window if not quiet
+// - unsets resource (for hook)
+// - prepares message for hook
+// - sends message
+// - checks for encryption error
+// - calls hook
+// So, we can make 'activeresource' checker, that will eliminate most of the checks,
+// we can move online check to caller space, we can do chatmode things only when not
+// quiet. That essentially leaves only send_message_to. However that causes mcabber
+// not enter chat mode, when on wrong buddy (status/group).
+// Add '--to' and '--subject' to commands.
+
 static int send_message_to(const char *fjid, const char *msg, const char *subj,
-                           LmMessageSubType type_overwrite, bool quiet)
+                           msgtype_t msg_type, bool quiet)
 {
   char *bare_jid, *rp;
   char *hmsg;
